#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <cstdlib>
#include <math.h>

using namespace std;

double fracpart(double w) {
    return (double) (w - (int) w);
}

double nearint(double y, double totolerence) {
    double tolerence = 0.0000001;
    double fpy = fracpart(y);
    if( fpy >= 0.0 && fpy < tolerence ) {
        return (double) ((int) y);
    }
    if( 1.0 > fpy && fpy > 1.0-tolerence ) {
        return (double) (1.0 + (int) y);
    }
    if( fpy < 0.0 && fpy > 0.0-tolerence ) {
        return (double) ((int) y);
    }
    if( -1.0 < fpy && fpy < -1.0+tolerence ) {
        return (double) (1.0 - (int) y);
    }
    return y;
}

int main(int argc, char *argv[]) {
    if(argc >= 8) {
        double angle;
        double startangle = (double) atof(argv[1]);
        double stopangle = (double) atof(argv[2]);
        double step = (double) atof(argv[3]);
        double xmagnification = (double) atof(argv[4]);
        double ymagnification = (double) atof(argv[5]);
        double xoffset = (double) atof(argv[6]);
        double yoffset = (double) atof(argv[7]);
        double tolerence = (double) atof(argv[8]);
        for(angle=startangle;angle<=stopangle;angle+=step) {
            cout << "\\put(";
            cout << nearint((angle/360.0)*xmagnification, tolerence)+yoffset;
            cout << ",";
            cout << nearint(sin(angle*3.14159/180.0)*ymagnification, tolerence)+xoffset;
            cout << "){\\circle*{0.06}}";
            cout << endl;
        }

        return EXIT_SUCCESS;
    } else {
        cout << "Manual" << endl;
    }
}
